"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = MDXContent;

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@mdx-js/react");

var _ui = require("@teambit/ui.mdx-scope-context");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var layoutProps = {};
var MDXLayout = "wrapper";

function MDXContent(_ref) {
  var components = _ref.components,
      props = _objectWithoutProperties(_ref, ["components"]);

  return (0, _react2.mdx)(MDXLayout, _extends({}, layoutProps, props, {
    components: components,
    mdxType: "MDXLayout"
  }), (0, _react2.mdx)(_ui.MDXScopeProvider, {
    components: {},
    mdxType: "MDXScopeProvider"
  }, (0, _react2.mdx)("p", null, "The built-in ", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "https://bit.dev/teambit/react/react-native"
  }, "React Native Component Development Environment"), " is a concrete composition of the ", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "https://bit.dev/teambit/envs/envs"
  }, "Env Aspect"), ". Use it when getting started with React Native components with Bit and later as a base for any future customization of your ReactNative-based workflow."), (0, _react2.mdx)("p", null, "React Native environment is composed out of the base ", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "https://bit.dev/teambit/react/react"
  }, "React Environment"), " with some specific overrides for dependency management."), (0, _react2.mdx)("h2", null, "Use React Native environment"), (0, _react2.mdx)("p", null, "To use this environment for your components, add it to any of the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "variants"), " in your ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "workspace.jsonc"), " file as follows:"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-json",
    "metastring": "title=\"workspace.jsonc\"",
    "title": "\"workspace.jsonc\""
  }, "{\n  \"teambit.workspace/variants\": {\n    \"some/path\": {\n      \"teambit.react/react-native\": {}\n    }\n  }\n}\n")), (0, _react2.mdx)("h2", null, "Create React Native components"), (0, _react2.mdx)("p", null, "React Native implements several component templates:"), (0, _react2.mdx)("ul", null, (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "react-native-env"), " boilerplate for customizing configuration.")), (0, _react2.mdx)("p", null, "Use any of these templates with the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "bit create"), " command:"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-sh"
  }, "bit create <template name> [components...]\n")), (0, _react2.mdx)("h2", null, "Default Configuration and Services"), (0, _react2.mdx)("p", null, "React Native, like all over Environments must implement a set of Service Handlers. For each service, React Native compose a different tool and config by default."), (0, _react2.mdx)("blockquote", null, (0, _react2.mdx)("p", {
    parentName: "blockquote"
  }, "React Native is a composition of the React environment with some specific modifications. Most of the links here direct to the actual configs in React environment.")), (0, _react2.mdx)("table", null, (0, _react2.mdx)("thead", {
    parentName: "table"
  }, (0, _react2.mdx)("tr", {
    parentName: "thead"
  }, (0, _react2.mdx)("th", {
    parentName: "tr",
    "align": null
  }, "Service"), (0, _react2.mdx)("th", {
    parentName: "tr",
    "align": null
  }, "Aspect"), (0, _react2.mdx)("th", {
    parentName: "tr",
    "align": null
  }, "Base Configuration"))), (0, _react2.mdx)("tbody", {
    parentName: "table"
  }, (0, _react2.mdx)("tr", {
    parentName: "tbody"
  }, (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, "Compilation"), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/typescript/typescript"
  }, "TypeScript")), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/react/react/~code/typescript/tsconfig.json"
  }, "tsconfig.json"))), (0, _react2.mdx)("tr", {
    parentName: "tbody"
  }, (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, "Testing"), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("strong", {
    parentName: "td"
  }, "Jest")), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/react/react/~code/jest/jest.config.js"
  }, "jest.config.js"))), (0, _react2.mdx)("tr", {
    parentName: "tbody"
  }, (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, "Linting"), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("strong", {
    parentName: "td"
  }, "ESLint")), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/react/react/~code/eslint/eslintrc.ts"
  }, "eslintrc.ts"))), (0, _react2.mdx)("tr", {
    parentName: "tbody"
  }, (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, "DevServer"), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("strong", {
    parentName: "td"
  }, "Webpack")), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/react/react/~code/webpack/webpack.config.preview.dev.ts"
  }, "webpack.config.preview.dev.ts"))), (0, _react2.mdx)("tr", {
    parentName: "tbody"
  }, (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, "Preview (simulation)"), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("strong", {
    parentName: "td"
  }, "Webpack")), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/react/react/~code/webpack/webpack.config.preview.ts"
  }, "webpack.config.preview.ts"))), (0, _react2.mdx)("tr", {
    parentName: "tbody"
  }, (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, "Package"), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("strong", {
    parentName: "td"
  }, "PKG")), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, "Base ", (0, _react2.mdx)("inlineCode", {
    parentName: "td"
  }, "package.json"), " props from ", (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/typescript/typescript/~code/typescript.main.runtime.ts"
  }, "TypeScript Aspect"))), (0, _react2.mdx)("tr", {
    parentName: "tbody"
  }, (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, "Bundling"), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("strong", {
    parentName: "td"
  }, "Webpack")), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/react/react/~code/webpack/webpack.config.preview.ts"
  }, "webpack.config.preview.ts"))), (0, _react2.mdx)("tr", {
    parentName: "tbody"
  }, (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, "Documentation"), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("em", {
    parentName: "td"
  }, "Core implementation")), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/react/react/~code/docs/index.tsx"
  }, "Docs template"))), (0, _react2.mdx)("tr", {
    parentName: "tbody"
  }, (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, "Build pipeline"), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/pipelines/builder"
  }, "Builder")), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/react/react/~code/react-native.env.ts"
  }, "Build pipeline"))), (0, _react2.mdx)("tr", {
    parentName: "tbody"
  }, (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, "Dependencies"), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("em", {
    parentName: "td"
  }, "Core implementation")), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/react/react-native/~code/react-native.env.ts"
  }, "Env-dependencies"))), (0, _react2.mdx)("tr", {
    parentName: "tbody"
  }, (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, "Component Generator"), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/generator/generator"
  }, "Generator")), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/react/react-native/~code/templates/react-native-component.ts"
  }, "example template"))))), (0, _react2.mdx)("h2", null, "Customize environment"), (0, _react2.mdx)("p", null, "All environments are extendible. You can take any pre-existing environment, and create a component to extend it. That component can then use APIs to:"), (0, _react2.mdx)("ul", null, (0, _react2.mdx)("li", {
    parentName: "ul"
  }, "Override default configurations."), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, "Replace composed tools with others (for example - use Babel instead of TypeScript)."), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, "Add new services and capabilities.")), (0, _react2.mdx)("h3", null, "Create an extension"), (0, _react2.mdx)("p", null, "The first step is to create a component that extends React Native. Use the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "react-native-env"), " template from React Native env."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-sh"
  }, "bit create react-native-env extensions/custom-react-native\n")), (0, _react2.mdx)("p", null, "As with any component, environments must themselves have an environment which compiles, builds, transpiles, etc, them. Bit has a special environment that knows how to create other environments - ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "teambit.harmony/aspect"), ". So for any component that is meant to be a Bit environment, you must set ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "teambit.harmony/aspect"), " as the environment for that component."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-json",
    "metastring": "title=\"add variant for the extension and set the aspect env\"",
    "title": "\"add",
    "variant": true,
    "for": true,
    "the": true,
    "extension": true,
    "and": true,
    "set": true,
    "aspect": true,
    "env\"": true
  }, "{\n  //...\n  \"teambit.workspace/variants\": {\n    //...\n    \"extensions/custom-react-native\": {\n      \"teambit.harmony/aspect\": {}\n    }\n    //...\n  }\n}\n")), (0, _react2.mdx)("p", null, "Validate the above by running ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "bit env"), " and see that the extension-component has ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "teambit.harmony/aspect"), " set as an environment."), (0, _react2.mdx)("p", null, "Now that you have a basic customized extension to start from, you can go ahead and configure it for your components in ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "workspace.json"), ":"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-json",
    "metastring": "title=\"edit variants and set the new env\"",
    "title": "\"edit",
    "variants": true,
    "and": true,
    "set": true,
    "the": true,
    "new": true,
    "env\"": true
  }, "{\n  //...\n  \"teambit.workspace/variants\": {\n    //...\n    \"[some]/[variant]\": {\n      \"[yourscope]/extensions/custom-react-native\": {}\n    }\n    //...\n  }\n}\n")), (0, _react2.mdx)("h3", null, "Customize configuration"), (0, _react2.mdx)("p", null, "React Native implements a set of APIs you can use to merge your preferred configuration with its defaults. These APIs are called ", (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "transformers"), " and they all start with the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "override"), " pre-fix. Find ", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "#transformers-api-docs"
  }, "Available transformers here"), ".\nIn case of a conflict, your config will override the default."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-typescript",
    "metastring": "{4,14} title=\"Customized TypeScript configuration\"",
    "{4,14}": true,
    "title": "\"Customized",
    "TypeScript": true,
    "configuration\"": true
  }, "import { EnvsMain, EnvsAspect } from '@teambit/envs';\nimport { ReactNativeAspect, ReactNativeMain } from '@teambit/react-native';\n\nconst tsconfig = require('./typescript/tsconfig.json');\n\nexport class CustomReactNativeExtension {\n  constructor(private reactNative: ReactNativeMain) {}\n\n  static dependencies: any = [EnvsAspect, ReactNativeAspect];\n\n  static async provider([envs, reactNative]: [EnvsMain, ReactNativeMain]) {\n    const customReactNativeEnv = reactNative.compose([reactNative.overrideTsConfig(tsconfig)]);\n\n    envs.registerEnv(customreactNativeEnv);\n\n    return new CustomReactNativeExtension(reactNative);\n  }\n}\n")), (0, _react2.mdx)("blockquote", null, (0, _react2.mdx)("p", {
    parentName: "blockquote"
  }, "To override any specific configuration it's recommended to create a separate config file with your customized configuration and import it into the main ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, ".extension.ts"), " file where you can supply it to the relevant ", (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "transformers"), ". See the tsconfig example in the above snippet.")), (0, _react2.mdx)("h3", null, "Composing tools and services"), (0, _react2.mdx)("p", null, "Environments use Environment Services by implementing a special class of methods called Service Handlers.\nThe supplied transformers allow overriding of these services - for instance the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "overrideCompiler"), " transformer allows overriding the environment's ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "getCompiler()"), " method."), (0, _react2.mdx)("p", null, "The below example uses the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "overrideCompiler"), " transformer to override the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "getCompiler()"), " Service Handler to change the compilation service."), (0, _react2.mdx)("ol", null, (0, _react2.mdx)("li", {
    parentName: "ol"
  }, "Add a Babel config file to your custom environment and import/require it in your ", (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, ".extension"), " file"), (0, _react2.mdx)("li", {
    parentName: "ol"
  }, "Create a new Babel compiler using the Babel aspect, and initialize it with the above babelConfig"), (0, _react2.mdx)("li", {
    parentName: "ol"
  }, "Use the ", (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "compose"), " Env API to apply the compiler override transformer and add Babel as a transpiler in the environment")), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-typescript",
    "metastring": "{3,5,10-12,15,17-18,22-23}",
    "{3,5,10-12,15,17-18,22-23}": true
  }, "import { EnvsMain, EnvsAspect } from '@teambit/envs';\nimport { ReactNativeAspect, ReactNativeMain } from '@teambit/react-native';\nimport { BabelAspect, BabelMain } from '@teambit/babel';\n\nconst babelConfig = require('./babel/babel.config');\n\nexport class CustomReactNativeExtension {\n  constructor(private reactNative: ReactNativeMain) {}\n\n  static dependencies: any = [EnvsAspect, reactNative, BabelAspect];\n\n  static async provider([envs, reactNative, babel]: [EnvsMain, ReactNativeMain, BabelMain]) {\n    const babelCompiler = babel.createCompiler({\n      babelTransformOptions: babelConfig,\n    });\n\n    const customReactNativeEnv = reactNative.compose([\n      reactNative.overrideCompiler(babelCompiler),\n      reactNative.overrideCompilerTasks([babelCompiler.createTask()]),\n    ]);\n\n    envs.registerEnv(customReactNativeEnv);\n    return new CustomReactNativeExtension(reactNative);\n  }\n}\n")), (0, _react2.mdx)("h3", null, "Transformers API docs"), (0, _react2.mdx)("p", null, "Use these APIs to customize the base React Native environment default configuration with your extension. ", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "#customizing-configuration"
  }, "Read more here"), "."), (0, _react2.mdx)("h4", null, (0, _react2.mdx)("inlineCode", {
    parentName: "h4"
  }, "overrideTsConfig(tsconfig: TsConfigSourceFile): EnvTransformer")), (0, _react2.mdx)("p", null, "Merges the environment's default TypeScript configuration with the contents of your ", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "https://www.typescriptlang.org/handbook/tsconfig-json.html"
  }, "typescript configuration file"), ".\nThis config affects the transpilation carried out when rendering components on the local dev UI. To override the config used when building components, use ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "overrideBuildTsConfig"), " below."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts"
  }, "// ...\nconst tsconfig = require('./typescript/tsconfig.json');\nexport class ReactNativeExtension {\n// ...\n\n  static async provider([envs, reactNative].: [EnvsMain, ReactNativeMain]) {\n    const newReactNativeEnv = reactNative.compose([\n      reactNative.overrideTsConfig(tsconfig)\n    ]);\n}\n// ...\n")), (0, _react2.mdx)("h4", null, (0, _react2.mdx)("inlineCode", {
    parentName: "h4"
  }, "overrideBuildTsConfig(tsconfig: TsConfigSourceFile): EnvTransformer")), (0, _react2.mdx)("p", null, "Merges the environment's default TypeScript configuration with the contents of your ", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "https://www.typescriptlang.org/handbook/tsconfig-json.html"
  }, "typescript configuration file"), ".\nThis config affects transpilation of component code during the build process, i.e. in preparation for packaging and exporting the component. To override the local ts config used when rendering components in the local UI, please use ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "overrideTsConfig"), " above."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts"
  }, "// ...\nconst tsconfig = require('./typescript/tsconfig.json');\nexport class ReactNativeExtension {\n// ...\n\n  static async provider([envs, reactNative].: [EnvsMain, ReactNativeMain]) {\n    const newReactNativeEnv = reactNative.compose([\n      reactNative.overrideTsConfig(tsconfig)\n    ]);\n}\n// ...\n")), (0, _react2.mdx)("h4", null, (0, _react2.mdx)("inlineCode", {
    parentName: "h4"
  }, "overridePreviewConfig(config: Configuration): EnvTransformer")), (0, _react2.mdx)("p", null, "Merges the Webpack configuration for the 'Preview' environment service, with the contents of your ", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "https://webpack.js.org/configuration/"
  }, "webpack configuration file"), ".\nThis webpack configuration is used for building and rendering your components on the local dev server."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts"
  }, "// ...\nconst webpackConfig = require('./webpack/webpack.config');\nexport class ReactNativeExtension {\n// ...\n  static async provider([envs, reactNative].: [EnvsMain, ReactNativeMain]) {\n    const newReactNativeEnv = reactNative.compose([\n      reactNative.overridePreviewConfig(webpackConfig)\n    ]);\n}\n// ...\n")), (0, _react2.mdx)("h4", null, (0, _react2.mdx)("inlineCode", {
    parentName: "h4"
  }, "overrideDevServerConfig(config: Configuration): EnvTransformer")), (0, _react2.mdx)("p", null, "Merges the Webpack configuration for the 'DevServer' environment service, with the contents of your ", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "https://webpack.js.org/configuration/"
  }, "webpack configuration file"), ".\nThis configuration is used for building and rendering the dev server UI (but not your components, which use the PreviewConfig)"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts"
  }, "// ...\nconst webpackConfig = require('./webpack/webpack.config');\nexport class ReactNativeExtension {\n// ...\n  static async provider([envs, reactNative].: [EnvsMain, ReactNativeMain]) {\n    const newReactNativeEnv = reactNative.compose([\n      reactNative.overrideDevServerConfig(webpackConfig)\n    ]);\n}\n// ...\n")), (0, _react2.mdx)("h4", null, (0, _react2.mdx)("inlineCode", {
    parentName: "h4"
  }, "overrideJestConfig(jestConfigPath: string): EnvTransformer")), (0, _react2.mdx)("p", null, "Merges the default configuration for the Jest test runner with the contents of your (", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "https://jestjs.io/en/configuration"
  }, "jest.config configuration file"), ")."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts"
  }, "// ...\nexport class ReactNativeExtension {\n// ...\n  static async provider([envs, reactNative].: [EnvsMain, ReactNativeMain]) {\n    const newReactNativeEnv = reactNative.compose([\n      reactNative.overrideJestConfig(require.resolve('./jest/jest.config'))\n    ]);\n}\n// ...\n")), (0, _react2.mdx)("h4", null, (0, _react2.mdx)("inlineCode", {
    parentName: "h4"
  }, "overrideBuildPipe(tasks: BuildTask[]): EnvTransformer")), (0, _react2.mdx)("p", null, "This method receives an array of build tasks. It merges the provided tasks with the environment's default build pipeline (initiated either on a ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "bit tag"), " or ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "bit build"), " command)."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts"
  }, "// ...\n// Import the task\nimport { CustomTask } from './custom.task'\nexport class CustomReactNative {\n  // ...\n  static async provider([envs, reactNative].: [EnvsMain, ReactNativeMain]) {\n    // Get the environment's default build pipeline using the 'getBuildPipe' service handler\n    const reactNativePipe = reactNative.env.getBuildPipe()\n    // Add the custom task to the end of the build tasks sequence.\n    const tasks = [...reactNativePipe, new CustomTask()]\n    const newReactNativeEnv = reactNative.compose([reactNative.overrideBuildPipe(tasks)])\n    // ...\n  }\n}\n")), (0, _react2.mdx)("h4", null, (0, _react2.mdx)("inlineCode", {
    parentName: "h4"
  }, "overrideDependencies(dependencyPolicy: DependenciesPolicy): EnvTransformer")), (0, _react2.mdx)("p", null, "This method receives a dependency-policy object and merges it with the environment's default dependency policy for components using this environment.\nEach key-value pair in a dependency-policy object signifies the package and the version to be used. Use also the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "-"), " and ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "+"), " notation to signify a module should moved between dependency types (dev, peer or standard)."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-js"
  }, "// ...\nconst newDependencies = {\n  devDependencies: {\n    '@types/jest': '~26.0.9'\n  }\n}\n\nexport class CustomReactNative {\n  // ...\n  static async provider([envs, reactNative].: [EnvsMain, ReactNativeMain]) {\n    const newReactNativeEnv = reactNative.compose([\n      reactNative.overrideDependencies(newDependencies)\n    ])\n    // ...\n  }\n}\n")), (0, _react2.mdx)("h4", null, (0, _react2.mdx)("inlineCode", {
    parentName: "h4"
  }, "overridePackageJsonProps(props: PackageJsonProps): EnvTransformer")), (0, _react2.mdx)("p", null, "Merges the provide props with the default properties added to the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "package.json"), " file of every package generated from components using this environment."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts"
  }, "// ...\nconst newPackageProps = {\n  main: 'dist/{main}.js',\n  types: '{main}.ts'\n}\n\nexport class CustomReactNative {\n  // ...\n  static async provider([envs, reactNative].: [EnvsMain, ReactNativeMain]) {\n    const newReactNativeEnv = reactNative.compose([\n      reactNative.overridePackageJsonProps(newPackageProps)\n    ])\n    // ...\n  }\n}\n")), (0, _react2.mdx)("p", null, "The built-in ", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "https://bit.dev/teambit/react/react-native"
  }, "React Native Component Development Environment"), " is a concrete composition of the ", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "https://bit.dev/teambit/envs/envs"
  }, "Env Aspect"), ". It compose different tools and configs that fit practices implemented in ", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "https://create-react-app.dev"
  }, "Create React Native App"), ". Use it when getting started with React Native components with Bit and later as a base for any future customization of your React-Native-based workflow."), (0, _react2.mdx)("p", null, "React Native environment is composed out of the base ", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "https://bit.dev/teambit/react/react"
  }, "React Environment"), " with some specific configuration overrides."), (0, _react2.mdx)("h2", null, "Use React Native environment"), (0, _react2.mdx)("p", null, "To use this environment for your components, add it to any of the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "variants"), " in your ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "workspace.jsonc"), " file as follows:"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-json",
    "metastring": "title=\"workspace.jsonc\"",
    "title": "\"workspace.jsonc\""
  }, "{\n  \"teambit.workspace/variants\": {\n    \"[some]/[path]\": {\n      \"teambit.react/react-native\": {}\n    }\n  }\n}\n")), (0, _react2.mdx)("h2", null, "Create React Native components"), (0, _react2.mdx)("p", null, "React implements several component templates:"), (0, _react2.mdx)("ul", null, (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "reactnative-env"), " boilerplate for customizing configuration.")), (0, _react2.mdx)("p", null, "Use any of these templates with the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "bit create"), " command:"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-sh"
  }, "bit create <template name> [components...]\n")), (0, _react2.mdx)("h2", null, "Runtime (framework) dependencies"), (0, _react2.mdx)("p", null, "Similar to many Frontend frameworks React Native must have a singleton instance in your app's runtime. When building reuseable components we need to adhere to that and have ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "react"), " and ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "react-native"), " set as ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "peerDependencies"), ", thus allowing the consuming app to determine runtime version. React environment implements this via the ", (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "Dependencies"), " service which is used to override ", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "https://bit.dev/teambit/dependencies/dependency-resolver"
  }, "dependency-resolver"), " and set your prefered dependencies.\nIt is recommended to for you to extend the base React environment and define a semantic version rule to fit your current tech stack and guidelines for reuseable React components."), (0, _react2.mdx)("h2", null, "Default Configuration and Services"), (0, _react2.mdx)("p", null, "React Native, like all over Environments must implement a set of Service Handlers. For each service, React Native compose a different tool and config by default."), (0, _react2.mdx)("blockquote", null, (0, _react2.mdx)("p", {
    parentName: "blockquote"
  }, "React Native is a composition of the React environment with some specific modifications. Most of the links here direct to the actual configs in React environment.")), (0, _react2.mdx)("table", null, (0, _react2.mdx)("thead", {
    parentName: "table"
  }, (0, _react2.mdx)("tr", {
    parentName: "thead"
  }, (0, _react2.mdx)("th", {
    parentName: "tr",
    "align": null
  }, "Service"), (0, _react2.mdx)("th", {
    parentName: "tr",
    "align": null
  }, "Aspect"), (0, _react2.mdx)("th", {
    parentName: "tr",
    "align": null
  }, "Base Configuration"))), (0, _react2.mdx)("tbody", {
    parentName: "table"
  }, (0, _react2.mdx)("tr", {
    parentName: "tbody"
  }, (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, "Compilation"), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/typescript/typescript"
  }, "TypeScript")), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/react/react/~code/typescript/tsconfig.json"
  }, "tsconfig.json"))), (0, _react2.mdx)("tr", {
    parentName: "tbody"
  }, (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, "Testing"), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("strong", {
    parentName: "td"
  }, "Jest")), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/react/react-native/~code/jest/jest.config.js"
  }, "jest.config.js"))), (0, _react2.mdx)("tr", {
    parentName: "tbody"
  }, (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, "Linting"), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("strong", {
    parentName: "td"
  }, "ESLint")), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/react/react/~code/eslint/eslintrc.ts"
  }, "eslintrc.ts"))), (0, _react2.mdx)("tr", {
    parentName: "tbody"
  }, (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, "DevServer"), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("strong", {
    parentName: "td"
  }, "Webpack")), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/react/react-native/~code/webpack/webpack.config.js"
  }, "webpack.config.preview.dev.ts"))), (0, _react2.mdx)("tr", {
    parentName: "tbody"
  }, (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, "Preview (simulation)"), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("strong", {
    parentName: "td"
  }, "Webpack")), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/react/react-native/~code/webpack/webpack.config.js"
  }, "webpack.config.preview.ts"))), (0, _react2.mdx)("tr", {
    parentName: "tbody"
  }, (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, "Package"), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("strong", {
    parentName: "td"
  }, "PKG")), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, "Base ", (0, _react2.mdx)("inlineCode", {
    parentName: "td"
  }, "package.json"), " props from ", (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/typescript/typescript/~code/typescript.main.runtime.ts"
  }, "TypeScript Aspect"))), (0, _react2.mdx)("tr", {
    parentName: "tbody"
  }, (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, "Bundling"), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("strong", {
    parentName: "td"
  }, "Webpack")), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/react/react-native/~code/webpack/webpack.config.js"
  }, "webpack.config.preview.ts"))), (0, _react2.mdx)("tr", {
    parentName: "tbody"
  }, (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, "Documentation"), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("em", {
    parentName: "td"
  }, "Core implementation")), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/react/react/~code/docs/index.tsx"
  }, "Docs template"))), (0, _react2.mdx)("tr", {
    parentName: "tbody"
  }, (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, "Build pipeline"), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/pipelines/builder"
  }, "Builder")), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/react/react/~code/react.env.ts"
  }, "Build pipeline"))), (0, _react2.mdx)("tr", {
    parentName: "tbody"
  }, (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, "Dependencies"), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("em", {
    parentName: "td"
  }, "Core implementation")), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/react/react-native/~code/react-native.main.runtime.ts"
  }, "Env-dependencies"))), (0, _react2.mdx)("tr", {
    parentName: "tbody"
  }, (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, "Component Generator"), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/teambit/generator/generator"
  }, "Generator")), (0, _react2.mdx)("td", {
    parentName: "tr",
    "align": null
  }, (0, _react2.mdx)("a", {
    parentName: "td",
    "href": "https://bit.dev/react/react-native/~code/templates/reactnative-component.ts"
  }, "example template"))))), (0, _react2.mdx)("h2", null, "Customize environment"), (0, _react2.mdx)("p", null, "All environments are extendible. You can take any pre-existing environment, and create a component to extend it. That component can then use APIs to:"), (0, _react2.mdx)("ul", null, (0, _react2.mdx)("li", {
    parentName: "ul"
  }, "Override default configurations."), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, "Replace composed tools with others (for example - use Babel instead of TypeScript)."), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, "Add new services and capabilities.")), (0, _react2.mdx)("h3", null, "Create an extension"), (0, _react2.mdx)("p", null, "The first step is to create a component that extends React Native. Use the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "react-native-env"), " template from React env."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-sh"
  }, "bit create react-native-env extensions/custom-react-native\n")), (0, _react2.mdx)("p", null, "After you created your extension you need configure it to be a Bit Aspect. This is because environments are actually aspects that extends Bit's core functionality to support your development workflow. To do this edit your workspace.jsonc and set ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "teambit.harmony/aspect"), " as the environment applied on the extension you created:"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-json",
    "metastring": "title=\"add variant for the extension and set the aspect env\"",
    "title": "\"add",
    "variant": true,
    "for": true,
    "the": true,
    "extension": true,
    "and": true,
    "set": true,
    "aspect": true,
    "env\"": true
  }, "{\n  //...\n  \"teambit.workspace/variants\": {\n    //...\n    \"extensions/custom-react-native\": {\n      \"teambit.harmony/aspect\": {}\n    }\n    //...\n  }\n}\n")), (0, _react2.mdx)("p", null, "Validate it by running ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "bit env"), " and see that the extension-component has ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "teambit.harmony/aspect"), " set as an environment."), (0, _react2.mdx)("p", null, "Now that you have a base extension to start from, you can already go ahead and configure it for your components in ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "workspace.json"), ":"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-json",
    "metastring": "title=\"edit variants and set the new env\"",
    "title": "\"edit",
    "variants": true,
    "and": true,
    "set": true,
    "the": true,
    "new": true,
    "env\"": true
  }, "{\n  //...\n  \"teambit.workspace/variants\": {\n    //...\n    \"[some]/[variant]\": {\n      \"[yourscope]/extensions/custom-react-native\": {}\n    }\n    //...\n  }\n}\n")), (0, _react2.mdx)("h3", null, "Customize configuration"), (0, _react2.mdx)("p", null, "React implements a set of APIs you can use to merge you preferred configuration with its defaults. These APIs are called ", (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "transformers"), " and they all start with the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "override"), " pre-fix. Find all ", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "#transformers-api-docs"
  }, "Available transformers here"), ".\nIn case of a conflict, your config will override the default."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-typescript",
    "metastring": "{4,13} title=\"Customized TypeScript configuration\"",
    "{4,13}": true,
    "title": "\"Customized",
    "TypeScript": true,
    "configuration\"": true
  }, "import { EnvsMain, EnvsAspect } from '@teambit/envs';\nimport { ReactNativeAspect, ReactNativeMain } from '@teambit/react-native';\n\nconst tsconfig = require('./typescript/tsconfig.json');\n\nexport class CustomReactNativeExtension {\n  constructor(private reactNative: ReactNativeMain) {}\n\n  static dependencies: any = [EnvsAspect, ReactNativeAspect];\n\n  static async provider([envs, reactNative]: [EnvsMain, ReactNativeMain]) {\n    const customReactNativeExtension = reactNative.compose([reactNative.overrideTsConfig(tsconfig)]);\n\n    envs.registerEnv(customReactNativeExtension);\n\n    return new CustomReactNativeExtension(reactNative);\n  }\n}\n")), (0, _react2.mdx)("blockquote", null, (0, _react2.mdx)("p", {
    parentName: "blockquote"
  }, "To override any specific configuration it's recommended to create a config file for the specific tool and import it to any of the ", (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "transformers"), ".")), (0, _react2.mdx)("h3", null, "Composing tools and services"), (0, _react2.mdx)("p", null, "Environments use Environment Services by implementing a special class of methods called Service Handlers.\nYou can override an environment's compiler replacing its Compiler Service Handler with the method ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "getCompiler()"), ".\n", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "#service-providers-api-docs"
  }, "Find all service handlers here"), "."), (0, _react2.mdx)("p", null, "The below example uses a Service Handler to change compilation service."), (0, _react2.mdx)("ol", null, (0, _react2.mdx)("li", {
    parentName: "ol"
  }, "Import the Babel extension component to configure it and set it as the new compiler"), (0, _react2.mdx)("li", {
    parentName: "ol"
  }, "Import your Babel config"), (0, _react2.mdx)("li", {
    parentName: "ol"
  }, "Set the necessary dependencies to be injected (by Bit) into the following 'provider' function"), (0, _react2.mdx)("li", {
    parentName: "ol"
  }, "Instantiate a new Babel compiler with the 'babelConfig' configurations"), (0, _react2.mdx)("li", {
    parentName: "ol"
  }, "use the ", (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "compose"), " Env API to register a new Service Hanlder")), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-typescript",
    "metastring": "{3,5,10-13,15-16,19-21}",
    "{3,5,10-13,15-16,19-21}": true
  }, "import { EnvsMain, EnvsAspect } from '@teambit/envs';\nimport { ReactNativeAspect, ReactNativeMain } from '@teambit/react-native';\nimport { BabelAspect, BabelMain } from '@teambit/babel';\n\nconst babelConfig = require('./babel/babel.config');\n\nexport class CustomReactNativeExtension {\n  constructor(private reactNative: ReactNativeMain) {}\n\n  static dependencies: any = [EnvsAspect, ReactNativeAspect, BabelAspect];\n\n  static async provider([envs, reactNative, babel]: [EnvsMain, ReactNativeMain, BabelMain]) {\n    const babelCompiler = babel.createCompiler({\n      babelTransformOptions: babelConfig,\n    });\n\n    const customReactNativeExtension = reactNative.compose([\n      reactNative.overrideCompiler(babelCompiler),\n      reactNative.overrideCompilerTasks([babelCompiler.createTask()]),\n    ]);\n\n    envs.registerEnv(customReactNativeExtension);\n    return new CustomReactNativeExtension(reactNative);\n  }\n}\n")), (0, _react2.mdx)("h3", null, "Transformers API docs"), (0, _react2.mdx)("p", null, "Use these APIs to customize React environment default configuration with your extension. ", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "#customizing-configuration"
  }, "React more here"), "."), (0, _react2.mdx)("h4", null, (0, _react2.mdx)("inlineCode", {
    parentName: "h4"
  }, "overrideTsConfig(tsconfig: TsConfigSourceFile): EnvTransformer")), (0, _react2.mdx)("p", null, "Merge the environment's default TypeScript configurations with a new (", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "https://www.typescriptlang.org/handbook/tsconfig-json.html"
  }, "tsconfig.json"), ") configuration file."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts"
  }, "// ...\nconst tsconfig = require('./typescript/tsconfig.json');\nexport class ReactNativeExtension {\n// ...\n\n  static async provider([envs, reactNative]: [EnvsMain, ReactNativeMain]) {\n    const newReactNativeEnv = reactNative.compose([\n      reactNative.overrideTsConfig(tsconfig)\n    ]);\n}\n// ...\n")), (0, _react2.mdx)("h4", null, (0, _react2.mdx)("inlineCode", {
    parentName: "h4"
  }, "overridePreviewConfig(config: Configuration): EnvTransformer")), (0, _react2.mdx)("p", null, "Merge the Webpack configurations for the 'Preview' environment service, with a new (", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "https://webpack.js.org/configuration/"
  }, "webpack.config.js"), ") configuration file."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts"
  }, "// ...\nconst webpackConfig = require('./webpack/webpack.config');\nexport class ReactNativeExtension {\n// ...\n  static async provider([envs, reactNative]: [EnvsMain, ReactNativeMain]) {\n    const newReactNativeEnv = reactNative.compose([\n      reactNative.overridePreviewConfig(webpackConfig)\n    ]);\n}\n// ...\n")), (0, _react2.mdx)("h4", null, (0, _react2.mdx)("inlineCode", {
    parentName: "h4"
  }, "overrideDevServerConfig(config: Configuration): EnvTransformer")), (0, _react2.mdx)("p", null, "Merge the Webpack configurations for the 'DevServer' environment service, with a new (", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "https://webpack.js.org/configuration/"
  }, "webpack.config.js"), ") configuration file."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts"
  }, "// ...\nconst webpackConfig = require('./webpack/webpack.config');\nexport class ReactNativeExtension {\n// ...\n  static async provider([envs, reactNative]: [EnvsMain, ReactNativeMain]) {\n    const newReactNativeEnv = reactNative.compose([\n      reactNative.overrideDevServerConfig(webpackConfig)\n    ]);\n}\n// ...\n")), (0, _react2.mdx)("h4", null, (0, _react2.mdx)("inlineCode", {
    parentName: "h4"
  }, "overrideJestConfig(jestConfigPath: string): EnvTransformer")), (0, _react2.mdx)("p", null, "This method receives a path (as a string) to a configuration file . Overrides the default configurations for the Jest test runner with a new (", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "https://jestjs.io/en/configuration"
  }, "jest.config"), ") configuration file. This is done by passing the ", (0, _react2.mdx)("em", {
    parentName: "p"
  }, "path"), " to the file as an argument."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts"
  }, "// ...\nexport class ReactNativeExtension {\n// ...\n  static async provider([envs, reactNative]: [EnvsMain, ReactNativeMain]) {\n    const newReactNativeEnv = reactNative.compose([\n      reactNative.overrideJestConfig(require.resolve('./jest/jest.config'))\n    ]);\n}\n// ...\n")), (0, _react2.mdx)("h4", null, (0, _react2.mdx)("inlineCode", {
    parentName: "h4"
  }, "overrideBuildPipe(tasks: BuildTask[]): EnvTransformer")), (0, _react2.mdx)("p", null, "This method receives an array of Bit tasks. It overrides the build pipeline of a component (initiated either on a ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "bit tag"), " or ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "bit build"), " command)."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts"
  }, "// ...\n// Import the task\nimport { CustomTask } from './custom.task';\nexport class ReactNative {\n  // ...\n  static async provider([envs, reactNative]: [EnvsMain, ReactNativeMain]) {\n    // Get the environment's default build pipeline using the 'getBuildPipe' service handler\n    const reactNativePipe = reactNative.env.getBuildPipe();\n    // Add the custom task to the end of the build tasks sequence.\n    const tasks = [...reactNativePipe, new CustomTask()];\n    const newReactNativeEnv = reactNative.compose([reactNative.overrideBuildPipe(tasks)]);\n    // ...\n  }\n}\n")), (0, _react2.mdx)("h4", null, (0, _react2.mdx)("inlineCode", {
    parentName: "h4"
  }, "overrideDependencies(dependencyPolicy: DependenciesPolicy): EnvTransformer")), (0, _react2.mdx)("p", null, "This method receives a Bit dependency-policy object. It overrides the default dependency policy for components using this environment.\nEach key-value pair in a dependency-policy object signifies the package and the version to be used. It also uses the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "-"), " notation to signify a module should not be defined as a dependency of a certain type (dev, peer or standard)."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-js"
  }, "// ...\nconst newDependencies = {\n  devDependencies: {\n    '@types/jest': '~26.0.9',\n  },\n};\n\nexport class CustomReactNative {\n  // ...\n  static async provider([envs, reactNative]: [EnvsMain, ReactNativeMain]) {\n    const newReactNativeEnv = reactNative.compose([reactNative.overrideDependencies(newDependencies)]);\n    // ...\n  }\n}\n")), (0, _react2.mdx)("blockquote", null, (0, _react2.mdx)("p", {
    parentName: "blockquote"
  }, "The above example shows the 'React Native' library being removed as a (runtime) dependency and added as a peer dependency.")), (0, _react2.mdx)("h4", null, (0, _react2.mdx)("inlineCode", {
    parentName: "h4"
  }, "overridePackageJsonProps(props: PackageJsonProps): EnvTransformer")), (0, _react2.mdx)("p", null, "Overrides the default properties added to the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "package.json"), " file of every package generated from components using this environment."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts"
  }, "// ...\nconst newPackageProps = {\n  main: 'dist/{main}.js',\n  types: '{main}.ts',\n};\n\nexport class CustomReactNative {\n  // ...\n  static async provider([envs, reactNative]: [EnvsMain, ReactNativeMain]) {\n    const newReactNativeEnv = reactNative.compose([reactNative.overridePackageJsonProps(newPackageProps)]);\n    // ...\n  }\n}\n")), (0, _react2.mdx)("h3", null, "Service providers API docs"), (0, _react2.mdx)("p", null, "Use these APIs to customize React environment default configuration with your extension. ", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "#composing-tools-and-services"
  }, "Read more here"), "."), (0, _react2.mdx)("h4", null, (0, _react2.mdx)("inlineCode", {
    parentName: "h4"
  }, "getTester(...args : any[]): Tester")), (0, _react2.mdx)("p", null, "Returns a test runner to be used by the Tester service."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts"
  }, "export class ReactNativeEnv implements Environment {\n  constructor(\n    // ...\n\n    // The Jest Aspect\n    private jestAspect: JestMain\n  ) {}\n  // ...\n  getTester(jestConfigPath: string, jestModule = jest): Tester {\n    const jestConfig = require.resolve('./jest/jest.config');\n    return this.jestAspect.createTester(jestConfig);\n  }\n}\n")), (0, _react2.mdx)("h4", null, (0, _react2.mdx)("inlineCode", {
    parentName: "h4"
  }, "getCompiler(...args : any[]): Compiler")), (0, _react2.mdx)("p", null, "Returns a compiler to be used by the Compiler service."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts"
  }, "export class ReactNativeEnv implements Environment {\nconstructor(\n    // ...\n    // The TypeScript aspect\n    private tsAspect: TypescriptMain\n){}\n// ...\ngetCompiler() {\n    const tsConfig = require.resolve('./typescript/tsconfig.json')\n    return this.tsAspect.createCompiler(tsConfig);\n}\n")), (0, _react2.mdx)("h4", null, (0, _react2.mdx)("inlineCode", {
    parentName: "h4"
  }, "getLinter(...args : any[]): Linter")), (0, _react2.mdx)("p", null, "Returns a linter to be used by the Linter service."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts"
  }, "export class ReactNativeEnv implements Environment {\n    constructor(){\n        // ...\n        // The ESLint aspect\n        private eslint: ESLintMain\n    }\n    // ...\n    getLinter() {\n        const eslintConfig = require.resolve('./eslint/eslintrc')\n        return this.eslint.createLinter({\n            config: eslintConfig,\n            // resolve all plugins from the react environment\n            pluginPath: __dirname,\n        });\n    }\n}\n")), (0, _react2.mdx)("h4", null, (0, _react2.mdx)("inlineCode", {
    parentName: "h4"
  }, "getDevServer(...args : any[]): DevServer")), (0, _react2.mdx)("p", null, "Returns a DevServer to be used by the DevServer service. (A DevServer is essentially the combination of the bundler configurations, together with a specified 'listen' port number)"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts"
  }, "export class ReactNativeEnv implements Environment {\n  constructor(\n    // ...\n    // The Webpack aspect\n    private webpack: WebpackMain\n  ) {}\n  // ...\n  getDevServer(): DevServer {\n    const withDocs = Object.assign(context, {\n      entry: context.entry.concat([require.resolve('./docs')]),\n    });\n    return this.webpack.createDevServer(withDocs, webpackConfig);\n  }\n}\n")), (0, _react2.mdx)("blockquote", null, (0, _react2.mdx)("p", {
    parentName: "blockquote"
  }, "The above example runs the dev server with the environment's documentation template.")), (0, _react2.mdx)("h4", null, (0, _react2.mdx)("inlineCode", {
    parentName: "h4"
  }, "getDocsTemplate(...args : any[]): string")), (0, _react2.mdx)("p", null, "Returns the path to the documentation template files, to be used by the Documentation service."), (0, _react2.mdx)("p", null, "For example (see docs files ", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "https://github.com/teambit/bit/tree/master/scopes/react/react/docs"
  }, "here"), "):"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts"
  }, "export class ReactNativeEnv implements Environment {\n  // ...\n  getDocsTemplate() {\n    return require.resolve('./docs');\n  }\n}\n")), (0, _react2.mdx)("h4", null, (0, _react2.mdx)("inlineCode", {
    parentName: "h4"
  }, "getPackageJsonProps(...args : any[]): object")), (0, _react2.mdx)("p", null, "Returns an object that defines the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "package.json"), " properties of the packages generated for components handled by this environment. This configuration is used by the Packager service."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts"
  }, "export class ReactNativeEnv implements Environment {\n  // ...\n  getPackageJsonProps() {\n    return {\n      main: 'dist/{main}.js',\n      types: '{main}.ts',\n    };\n  }\n}\n")), (0, _react2.mdx)("blockquote", null, (0, _react2.mdx)("p", {
    parentName: "blockquote"
  }, "As with any other 'merging' process, the properties defined in the above returned object will be added to configurations set by Bit.\nConflicting properties will be overridden by the properties that are set here.\nConfigurations that are set here may also be overridden, either by the 'pkg aspect' or by workspace configurations set using the 'variants API'.")), (0, _react2.mdx)("h4", null, (0, _react2.mdx)("inlineCode", {
    parentName: "h4"
  }, "getDependencies(component: any): Promise<DependencyList>")), (0, _react2.mdx)("p", null, "Returns an object that defines the default dependencies for components handled by this environment. The returned object is used by the Dependencies service."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts"
  }, "export class ReactNativeEnv implements Environment {\n  // ...\n  async getDependencies() {\n    return {\n      dependencies: {\n        react: '-',\n      },\n      devDependencies: {\n        '@types/react': '16.9.43',\n        '@types/jest': '~26.0.9',\n      },\n      peerDependencies: {\n        react: '^16.13.1',\n        'react-dom': '^16.13.1',\n      },\n    };\n  }\n}\n")), (0, _react2.mdx)("blockquote", null, (0, _react2.mdx)("p", {
    parentName: "blockquote"
  }, "As with any other 'merging' process, the properties defined in the above returned object will be added to configurations set by Bit.\nConflicting properties will be overridden by the properties that are set here.\nConfigurations that are set here may also be overridden, either by the 'Dependency Resolver aspect' or by workspace configurations set using the 'variants API'.")), (0, _react2.mdx)("h4", null, (0, _react2.mdx)("inlineCode", {
    parentName: "h4"
  }, "getBuildPipe(...args : any[]): BuildTask[]")), (0, _react2.mdx)("p", null, "Returns an array of build tasks to be used by the Builder service. Tasks will be added after and before Bit's pre-configured build tasks."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-ts"
  }, "export class ReactNativeEnv implements Environment {\n  constructor(\n    // ...\n    // The Compiler aspect\n    private compiler: CompilerMain,\n    // The Tester aspect\n    private tester: TesterMain\n  ) {}\n  getBuildPipe(): BuildTask[] {\n    return [this.compiler.createTask('StencilCompiler', this.getCompiler()), this.tester.task];\n  }\n}\n"))));
}

;
MDXContent.isMDXComponent = true;

//# sourceMappingURL=react-native.mdx.js.map